/*
 * lora_modul.c
 *
 *  Created on: 12. 3. 2021
 *      Author: David
 */

#include "main.h"
#include "string.h"
#include "math.h"
#include "stdio.h"
#include <stdlib.h>

//Definice vsech potrebnych promennych
extern uint8_t flag;
extern uint8_t buff[255];
extern I2C_HandleTypeDef hi2c2;
extern UART_HandleTypeDef huart6;

const int MPU_ADDR = 0xD0;
volatile int16_t accelerometer_x, accelerometer_y, accelerometer_z;
volatile int16_t gyro_x, gyro_y, gyro_z;
volatile int16_t temperature;
volatile float Ax, Ay, Az, Gx, Gy, Gz, Temp;

uint8_t Rx_data [8];

char buffStr[255];
char nmeaSnt[80];

char *rawSum;
char smNmbr[3];


char *latRaw;
char latDg[2];
char latMS[7];
char *hemNS;


char *lonRaw;
char lonDg[3];
char lonMS[7];
char *hemEW;

char *utcRaw;
char strUTC[8];

char hH[2];
char mM[2];
char sS[2];

float latitude, longitude;

uint8_t cnt = 0;
uint8_t GPS_valid = 0;





int Usart6Recv(void) {							//Funkce pro cteni dat z UART6
	while (!(USART6->ISR & USART_ISR_RXNE))		//cekej dokud neprijde
		;
	return USART6->RDR;							//vycti a vrat jako hodnotu
}

void Usart6Send(char c) {						//Funkce pro odesilani dat UART6
	while (!(USART6->ISR & USART_ISR_TXE))
		;           							//cekej dokud neni volny TDR
	USART6->TDR = c;    						// zapis do TDR k odeslani
}


void Lora_Module_Init(void){	//Inicializace USI modoulu
	int i=0;
	char send_data[]="ATZ";											//Restart modulu
	char send_data1[]="AT+DEFMODE=6";								//Nastaveni pracovniho rezimu
	char send_data2[]="AT+RF=20,867100000,9,0,1,0,500,0,0";			//Nastaveni frekvence a dalsich radiovych parametru
	char send_data3[]="AT+DC=1";									//Nastaveni pracovniho cyklu
	char send_data4[]="AT+DR=3";									//Nastaveni rychlosti prenosu
	char send_data5[]="AT+RX2DR=5";									//Nastaveni rychlosi prenosu dat pro druhe okno
	char send_data6[]="AT+CHMSK=00000000000000000000000000000000";	//Nastaveni masky kanalu
	char send_data7[]="AT+WDCT";									//Ulozeni nastaveni do pameti modulu

	//Odesilani jednotlivych prikazu
	memset(Rx_data, 0, 8);
	printf("Beginning Lora\r\n");

	for(i=0;i<sizeof(send_data);i++){
 		Usart6Send(send_data[i]);
	}
	Usart6Send(13);

	HAL_Delay(200);

	for(i=0;i<sizeof(send_data1);i++){
		Usart6Send(send_data1[i]);
	}
	Usart6Send(13);

	HAL_Delay(200);

	for(i=0;i<sizeof(send_data2);i++){
		Usart6Send(send_data2[i]);
	}
	Usart6Send(13);


	HAL_Delay(200);


	for(i=0;i<sizeof(send_data3);i++){
		Usart6Send(send_data3[i]);
	}
	Usart6Send(13);


	HAL_Delay(200);

	for(i=0;i<sizeof(send_data4);i++){
		Usart6Send(send_data4[i]);
	}
	Usart6Send(13);


	HAL_Delay(300);

	for(i=0;i<sizeof(send_data5);i++){
		Usart6Send(send_data5[i]);
	}
	Usart6Send(13);


	HAL_Delay(300);

	for(i=0;i<sizeof(send_data6);i++){
		Usart6Send(send_data6[i]);
	}
	Usart6Send(13);


	HAL_Delay(200);

	for(i=0;i<sizeof(send_data7);i++){
		Usart6Send(send_data7[i]);
	}
	Usart6Send(13);


	HAL_Delay(1000);


}

void string2hexString(char* input, char* output) //prevod textoveho retezce na retezec hexadecimalnich hodnot
{
    int loop;
    int i;

    i=0;
    loop=0;

    while(input[loop] != '\0')
    {
        sprintf((char*)(output+i),"%02x", input[loop]);
        loop+=1;
        i+=2;
    }

    output[i++] = '\0';
}

void MPU_6050_Init(void){	//Inicializace gyroskopu a akcelerometru
	uint8_t check;
	uint8_t Data;
	HAL_I2C_Mem_Read(&hi2c2, MPU_ADDR,0x75,1, &check, 1, 1000); //0x75 adresa zařízení

	if ( check != 104 ) {
		printf("I2C Gyro Error Tx\r\n");
	} else {
		printf("I2C Gyro OK Tx\r\n");

		Data = 0;
		HAL_I2C_Mem_Write(&hi2c2, MPU_ADDR, 0x6B, 1,&Data, 1, 1000); //0x6B power managment, probuzeni modulu

		Data = 0x07;
		HAL_I2C_Mem_Write(&hi2c2, MPU_ADDR, 0x19, 1, &Data, 1, 1000); //Ox19 Tento registr určuje dělič z výstupní rychlosti gyroskopu použitý ke generování vzorkovací frekvence pro MPU6050.

		Data = 0x00;
		HAL_I2C_Mem_Write(&hi2c2, MPU_ADDR, 0x1B, 1, &Data, 1, 1000); //0x1B Nastaveni plneho rozsahu Gyroskopu

		Data = 0x00;
		HAL_I2C_Mem_Write(&hi2c2, MPU_ADDR, 0x1C, 1, &Data, 1, 1000); //0x1C Nastaveni plneho rozsahu Akcelerometru
	  }
}

void MPU_6050_Read_Gyro(void){ //Funkce pro vycteni dat Gyroskopu
	uint8_t recv[6];

	HAL_I2C_Mem_Read (&hi2c2, MPU_ADDR, 0x43, 1, recv, 6, 1000); // Vycteni 6 bajtu dat zacinajicich GYRO_XOUT_H registrem (0x43)

	gyro_x = (int16_t)(recv[0] << 8 | recv [1]);
	gyro_y = (int16_t)(recv[2] << 8 | recv [3]);
	gyro_z = (int16_t)(recv[4] << 8 | recv [5]);

	/***
		Převedení hodnoty RAW na dps (° / s)
		musíme rozdělit podle hodnoty celé stupnice nastavené v FS_SEL
		Nakonfiguroval jsem FS_SEL = 0. Takže vydělím 131,0              ****/

	Gx = gyro_x/131.0;
	Gy = gyro_y/131.0;
	Gz = gyro_z/131.0;
}

void MPU_6050_Read_Accel(void){ //Funkce pro vycteni dat Akcelerometru
	uint8_t recv[6];

	HAL_I2C_Mem_Read (&hi2c2, MPU_ADDR, 0x3B, 1, recv, 6, 1000); // Vycteni 6 bajtu dat zacinajicich ACCEL_XOUT_H registrem (0x3B)

	accelerometer_x = (int16_t)(recv[0] << 8 | recv [1]);
	accelerometer_y = (int16_t)(recv[2] << 8 | recv [3]);
	accelerometer_z = (int16_t)(recv[4] << 8 | recv [5]);

	/*** Převedení hodnoty RAW na zrychlení v 'g'
		musíme rozdělit podle hodnoty celé stupnice nastavené v FS_SEL
		Nakonfiguroval jsem FS_SEL = 0. Takže vydělím 16384.0              ****/

	Ax = accelerometer_x/16384.0;
	Ay = accelerometer_y/16384.0;
	Az = accelerometer_z/16384.0;
}

void MPU_6050_Read_Temp(void){ //Funkce pro vycteni dat Teplomeru
	uint8_t recv[6];

	HAL_I2C_Mem_Read (&hi2c2, MPU_ADDR, 0x41, 1, recv, 6, 1000); //Cteni registru teplomeru 0x41

	temperature = (int16_t)(recv[0] << 8 | recv [1]);
	Temp = temperature/340 + 36.53;
}


// funkce pro výpočet kontrolního součtu věty NMEA
int nmea0183_checksum(char *msg) {
	int checksum = 0;
	int j = 0;

	// první znak $ a poslední dva bajty původního CRC + znak *
	for (j = 1; j < strlen(msg) - 4; j++) {
		checksum = checksum ^ (unsigned) msg[j];
	}
	return checksum;
}

void Read_GPS_Data(void){ // Cteni GPS dat
	/*

	$ - Spozsteci oddelovac
	* - Oddělovač kontrolního součtu
	, - Oddělovač pole

	1. $ GNGLL hlavička protokolu
	2. Zeměpisná šířka (Ddmm.mm) [Rovník má zeměpisnou šířku 0 °, severní pól 90 ° severní šířky (psáno 90 ° severní šířky nebo + 90 °)]
	3. Směr zeměpisné šířky (N = sever, S = jih)
	4. Zeměpisná délka (DDDmm.mm) [0 ° na nultém poledníku do +180 ° na východ a  180 ° na západ]
	5. Směr zeměpisné délky (E = východ, W = západ)
	6. UTC časový stav polohy (hodiny / minuty / sekundy / desetinná sekundy) hhmmss
	7. Stav dat: A = Data platná, V = Data neplatná
	8. Indikátor režimu polohovacího systému
	9. * xx Kontrolní součet
	10. [CR] [LF] Terminátor věty. V C \r \n (dva znaky).

	*/

	memset(buffStr, 0, 255);

	sprintf(buffStr, "%s", buff);


	char *token, *string;

	string = strdup(buffStr);

	// rozdělení buffStr oddělovačem "\n" pomocí funkce strsep
	while ((token = strsep(&string, "\n")) != NULL) {
		memset(nmeaSnt, 0, 80);

		sprintf(nmeaSnt, "%s", token);
		// výběr pouze vět $ GNGLL, kombinace GPS a GLONASS
		// na mém GPS senzoru má tato dobrá věta NMEA vždy 50 znaků
		if ((strstr(nmeaSnt, "$GPGLL") != 0) && strlen(nmeaSnt) > 49 && strstr(nmeaSnt, "*") != 0) {
			GPS_valid = 1;
			rawSum = strstr(nmeaSnt, "*");
			memcpy(smNmbr, &rawSum[1], 2);
			smNmbr[2] = '\0';
			uint8_t intSum = nmea0183_checksum(nmeaSnt);
			char hex[2];

			// „% X“ hexadecimální celé číslo bez znaménka (velká písmena)
			sprintf(hex, "%X", intSum);


			// ověření údajů kontrolního součtu zda pokud je v pořádku
			if (strstr(smNmbr, hex) != NULL) {


			    cnt = 0;


			    // rozdělení věty na části oddělovačem ","
			    for (char *pV = strtok(nmeaSnt, ","); pV != NULL; pV = strtok(NULL, ",")) {
			    	switch (cnt) {
			        	case 1:
			        		latRaw = strdup(pV);
			            	break;
			            case 2:
			                hemNS = strdup(pV);
			                break;
			            case 3:
			                lonRaw = strdup(pV);
			                break;
			            case 4:
			                hemEW = strdup(pV);
			                break;
			            case 5:
			                utcRaw = strdup(pV);
			                break;
			         }

			         cnt++;

			    }

			    //Rozdeleni surovych dat na Stupne a Sekundy

			    memcpy(latDg, &latRaw[0], 2);
			    latDg[2] = '\0';

			    memcpy(latMS, &latRaw[2], 7);
			    latMS[7] = '\0';

			    memcpy(lonDg, &lonRaw[0], 3);
			    lonDg[3] = '\0';

			    memcpy(lonMS, &lonRaw[3], 7);
			    lonMS[7] = '\0';
			    char strLonMS[7];
			    sprintf(strLonMS, "%s", lonMS);

			    memcpy(hH, &utcRaw[0], 2);
			    hH[2] = '\0';

			    memcpy(mM, &utcRaw[2], 2);
			    mM[2] = '\0';

			    memcpy(sS, &utcRaw[4], 2);
			    sS[2] = '\0';

			    strcpy(strUTC, hH);
			    strcat(strUTC, ":");
			    strcat(strUTC, mM);
			    strcat(strUTC, ":");
			    strcat(strUTC, sS);
			    strUTC[8] = '\0';

			    latitude = atof(latDg)+((atof(latMS))/60);
			    longitude = atof(lonDg)+((atof(strLonMS))/60);

			}

		}

	}
}


//Odeslani vsech dat

void Send_GPS_Gyro_Accel_data(int id, float ax, float ay, float az, float gx, float gy, float gz, float latitude, float longitude, float temp){
	//Deklerace pomocnych promennych
	char res_ax[6];
	char res_ay[6];
	char res_az[6];
	char res_gx[8];
	char res_gy[8];
	char res_gz[8];
	char res_lat[10];
	char res_lon[10];
	char res_temp[6];
	char res_id[5];

	//Prevedeni cislene hodnoty na textovou
	snprintf(res_ax, sizeof res_ax, "%f", ax);
	snprintf(res_ay, sizeof res_ay, "%f", ay);
	snprintf(res_az, sizeof res_az, "%f", az);
	snprintf(res_gx, sizeof res_gx, "%f", gx);
	snprintf(res_gy, sizeof res_gy, "%f", gy);
	snprintf(res_gz, sizeof res_gz, "%f", gz);
	snprintf(res_lat, sizeof res_lat, "%f", latitude);
	snprintf(res_lon, sizeof res_lon, "%f", longitude);
	snprintf(res_temp, sizeof res_temp, "%f", temp);
	snprintf(res_id, sizeof res_id, "%d", id);


	//Zacetek obsahu zpravy
	char comm[11]="<";
	strcat(comm, res_id);
	strcat(comm, ">lat=");


	uint8_t DATA_SIZE_GPS = 10;
	uint8_t DATA_SIZE_GYRO = 8;
	uint8_t DATA_SIZE_ACCEL = 6;
	uint8_t DATA_SIZE_TEMP = 5;
	uint8_t COMMAND_SIZE=sizeof(comm);
	char  out[COMMAND_SIZE+2*(DATA_SIZE_GPS)+3*(DATA_SIZE_ACCEL)+3*(DATA_SIZE_GYRO)+DATA_SIZE_TEMP+16];

	//sestaveni retezce s daty a jejich identifikatory
	strcpy(out, comm);
	strcat(out, res_lat);
	strcat(out, "lon=");
	strcat(out, res_lon);
	strcat(out, "ax=");
	strcat(out, res_ax);
	strcat(out, "ay=");
	strcat(out, res_ay);
	strcat(out, "az=");
	strcat(out, res_az);
	strcat(out, "gx=");
	strcat(out, res_gx);
	strcat(out, "gy=");
	strcat(out, res_gy);
	strcat(out, "gz=");
	strcat(out, res_gz);
	strcat(out, "tmp=");
	strcat(out, res_temp);

	int len = strlen(out);
	char hex_str[(len*2)+1];

	//prevod na hexadecimalni hodnotu
	string2hexString(out, hex_str);

	//sestaveni prikazu USI pro odesilani dat
	char comm2[]="AT+TXT=1,";
	uint16_t DATA_SIZE2 = strlen(hex_str);
	uint8_t COMMAND_SIZE2=sizeof(comm2);
	char src111[DATA_SIZE2], out2[COMMAND_SIZE2+DATA_SIZE2];

	strcpy(src111, hex_str);
	strcpy(out2, comm2);
	strcat(out2, src111);

	//Odesilani koncoveho retezce
	int i;
	for(i=0;i<sizeof(out2);i++){
		Usart6Send(out2[i]);
	}
	Usart6Send(13);
}

