/*
 * lora_modul.c
 *
 *  Created on: 12. 3. 2021
 *      Author: David
 */

#include "main.h"
#include "string.h"
#include "math.h"
#include "stdio.h"
#include <stdlib.h>


extern uint8_t flag;
extern uint8_t buff[255];
extern I2C_HandleTypeDef hi2c2;

const int MPU_ADDR = 0xD0; //adresa gyroskopu
volatile int16_t accelerometer_x, accelerometer_y, accelerometer_z; // variables for accelerometer raw data
volatile int16_t gyro_x, gyro_y, gyro_z; // variables for gyro raw data
volatile int16_t temperature; // variables for temperature data
volatile float Ax, Ay, Az, Gx, Gy, Gz, Temp;

char buffStr[255];
char nmeaSnt[80];

char *rawSum;
char smNmbr[3];

// The Equator has a latitude of 0°,
//the North Pole has a latitude of 90° North (written 90° N or +90°),
//and the South Pole has a latitude of 90° South (written 90° S or �?�90°)

char *latRaw;
char latDg[2];
char latMS[7];
char *hemNS;

// longitude in degrees (0° at the Prime Meridian to +180° eastward and �?�180° westward)
// that is why 3
char *lonRaw;
char lonDg[3];
char lonMS[7];
char *hemEW;

char *utcRaw; // raw UTC time from the NMEA sentence in the hhmmss format
char strUTC[8]; // UTC time in the readable hh:mm:ss format

char hH[2]; // hours
char mM[2]; // minutes
char sS[2]; // seconds

float latitude, longitude;

uint8_t cnt = 0;
uint8_t GPS_valid = 0;





int Usart6Recv(void) {
	while (!(USART6->ISR & USART_ISR_RXNE))// cekej dokud neprijde
		;
	return USART6->RDR;      // vycti a vrat jako hodnotu
}

void Usart6Send(char c) {
	while (!(USART6->ISR & USART_ISR_TXE))
		;           // cekej dokud neni volny TDR
	USART6->TDR = c;    // zapis do TDR k odeslani
}


void Lora_Module_Init(void){
	int i=0;
		char send_data[]="ATZ";
		char send_data1[]="AT+DEFMODE=6";
		char send_data2[]="AT+RF=20,867100000,9,0,1,0,8,0,0";
		char send_data3[]="AT+DC=1";
		char send_data4[]="AT+DR=3";
		char send_data5[]="AT+RX2DR=5";
		char send_data6[]="AT+CHMSK=00000000000000000000000000000000";
		char send_data7[]="AT+WDCT";
		printf("Beginning Lora\r\n");

		for(i=0;i<sizeof(send_data);i++){
	 		Usart6Send(send_data[i]);
		}
		Usart6Send(13);

		HAL_Delay(200);

		for(i=0;i<sizeof(send_data1);i++){
			Usart6Send(send_data1[i]);
		}
		Usart6Send(13);

		HAL_Delay(200);

		for(i=0;i<sizeof(send_data2);i++){
			Usart6Send(send_data2[i]);
		}
		Usart6Send(13);

		HAL_Delay(200);


		for(i=0;i<sizeof(send_data3);i++){
			Usart6Send(send_data3[i]);
		}
		Usart6Send(13);

		HAL_Delay(200);

		for(i=0;i<sizeof(send_data4);i++){
			Usart6Send(send_data4[i]);
		}
		Usart6Send(13);

		HAL_Delay(300);

		for(i=0;i<sizeof(send_data5);i++){
			Usart6Send(send_data5[i]);
		}
		Usart6Send(13);

		HAL_Delay(300);

		for(i=0;i<sizeof(send_data6);i++){
			Usart6Send(send_data6[i]);
		}
		Usart6Send(13);

		HAL_Delay(200);

		for(i=0;i<sizeof(send_data7);i++){
			Usart6Send(send_data7[i]);
		}
		Usart6Send(13);

		HAL_Delay(1000);

}

void string2hexString(char* input, char* output)
{
    int loop;
    int i;

    i=0;
    loop=0;

    while(input[loop] != '\0')
    {
        sprintf((char*)(output+i),"%02x", input[loop]);
        loop+=1;
        i+=2;
    }
    //insert NULL at the end of the output string
    output[i++] = '\0';
}

void MPU_6050_Init(void){
	uint8_t check;
	uint8_t Data;
	HAL_I2C_Mem_Read(&hi2c2, MPU_ADDR,0x75,1, &check, 1, 1000); //0x75 adresa zařízení

	if ( check != 104 ) {
		printf("I2C Gyro Error Tx\r\n");
	} else {
		printf("I2C Gyro OK Tx\r\n");

		Data = 0;
		HAL_I2C_Mem_Write(&hi2c2, MPU_ADDR, 0x6B, 1,&Data, 1, 1000); //0x6B power managment, wake up

		Data = 0x07;
		HAL_I2C_Mem_Write(&hi2c2, MPU_ADDR, 0x19, 1, &Data, 1, 1000); //Ox19 This register specifies the divider from the gyroscope output rate used to generate the Sample Rate for the MPU6050.

		Data = 0x00;
		HAL_I2C_Mem_Write(&hi2c2, MPU_ADDR, 0x1B, 1, &Data, 1, 1000); //configure the Gyroscope  Writing (0x00) to these registers would set the Full scale range

		Data = 0x00;
		HAL_I2C_Mem_Write(&hi2c2, MPU_ADDR, 0x1C, 1, &Data, 1, 1000); //configure the Accelerometer Writing (0x00) to these registers would set the Full scale range
	  }
}

void MPU_6050_Read_Gyro(void){
	uint8_t recv[6];

	HAL_I2C_Mem_Read (&hi2c2, MPU_ADDR, 0x43, 1, recv, 6, 1000); // Read 6 BYTES of data starting from GYRO_XOUT_H register

	gyro_x = (int16_t)(recv[0] << 8 | recv [1]);
	gyro_y = (int16_t)(recv[2] << 8 | recv [3]);
	gyro_z = (int16_t)(recv[4] << 8 | recv [5]);

	/*** convert the RAW values into dps (°/s)
	we have to divide according to the Full scale value set in FS_SEL
	I have configured FS_SEL = 0. So I am dividing by 131.0
	for more details check GYRO_CONFIG Register              ****/

	Gx = gyro_x/131.0;
	Gy = gyro_y/131.0;
	Gz = gyro_z/131.0;
}

void MPU_6050_Read_Accel(void){
	uint8_t recv[6];

	HAL_I2C_Mem_Read (&hi2c2, MPU_ADDR, 0x3B, 1, recv, 6, 1000); // Read 6 BYTES of data starting from ACCEL_XOUT_H register

	accelerometer_x = (int16_t)(recv[0] << 8 | recv [1]);
	accelerometer_y = (int16_t)(recv[2] << 8 | recv [3]);
	accelerometer_z = (int16_t)(recv[4] << 8 | recv [5]);

	/*** convert the RAW values into acceleration in 'g'
	we have to divide according to the Full scale value set in FS_SEL
	I have configured FS_SEL = 0. So I am dividing by 16384.0
	for more details check ACCEL_CONFIG Register              ****/

	Ax = accelerometer_x/16384.0;
	Ay = accelerometer_y/16384.0;
	Az = accelerometer_z/16384.0;
}

void MPU_6050_Read_Temp(void){
	uint8_t recv[6];

	HAL_I2C_Mem_Read (&hi2c2, MPU_ADDR, 0x41, 1, recv, 6, 1000); //Read Temperature register

	temperature = (int16_t)(recv[0] << 8 | recv [1]);
	Temp = temperature/340 + 36.53;
}

// function to calculate checksum of the NMEA sentence
// -4, but not -3 because the NMEA sentences are delimited with \r\n, and there also is the invisible \r in the end
int nmea0183_checksum(char *msg) {
	int checksum = 0;
	int j = 0;

	// the first $ sign and the last two bytes of original CRC + the * sign
	for (j = 1; j < strlen(msg) - 4; j++) {
		checksum = checksum ^ (unsigned) msg[j];
	}
	return checksum;
}

void Read_GPS_Data(void){
	/*

	$ - Start delimiter
	* - Checksum delimiter
	, - Field delimiter

	1. $GNGLL log header
	2. Latitude (Ddmm.mm) [The Equator has a latitude of 0°, the North Pole has a latitude of 90° North (written 90° N or +90°)]
	3. Latitude direction (N = North, S = South)
	4. Longitude (DDDmm.mm) [0° at the Prime Meridian to +180° eastward and �?�180° westward]
	5. Longitude direction (E = East, W = West)
	6. UTC time status of position (hours/minutes/seconds/decimal seconds) hhmmss
	7. Data status: A = Data valid, V = Data invalid
	8. Positioning system mode indicator
	9. *xx Checksum
	10. [CR][LF] Sentence terminator. In C \r\n (two characters).
		or \r Carriage return
		or \n Line feed, end delimiter

	*/

	memset(buffStr, 0, 255);

	sprintf(buffStr, "%s", buff);


	// splitting the buffStr by the "\n" delimiter with the strsep() C function
	char *token, *string;

	string = strdup(buffStr);

	// actually splitting the string by "\n" delimiter
	while ((token = strsep(&string, "\n")) != NULL) {
		memset(nmeaSnt, 0, 80);

		sprintf(nmeaSnt, "%s", token);
		// selecting only $GNGLL sentences, combined GPS and GLONASS
		// on my GPS sensor this good NMEA sentence is always 50 characters
		if ((strstr(nmeaSnt, "$GPGLL") != 0) && strlen(nmeaSnt) > 49 && strstr(nmeaSnt, "*") != 0) {
			GPS_valid = 1;
			rawSum = strstr(nmeaSnt, "*");
			memcpy(smNmbr, &rawSum[1], 2);
			smNmbr[2] = '\0';
			uint8_t intSum = nmea0183_checksum(nmeaSnt);
			char hex[2];

			// "%X" unsigned hexadecimal integer (capital letters)
			sprintf(hex, "%X", intSum);

			// checksum data verification, if OK, then we can really trust
			// the data in the the NMEA sentence
			if (strstr(smNmbr, hex) != NULL) {

				//if we want display good $GNGLL NMEA sentences
			    //HAL_UART_Transmit(&huart2, nmeaSnt, 50, 70);
			    //HAL_UART_Transmit(&huart2, (uint8_t*) "\n", 1, 200);

			    cnt = 0;

			    // splitting the good NMEA sentence into the tokens by the comma delimiter
			    for (char *pV = strtok(nmeaSnt, ","); pV != NULL; pV = strtok(NULL, ",")) {
			    	switch (cnt) {
			        	case 1:
			        		latRaw = strdup(pV);
			            	break;
			            case 2:
			                hemNS = strdup(pV);
			                break;
			            case 3:
			                lonRaw = strdup(pV);
			                break;
			            case 4:
			                hemEW = strdup(pV);
			                break;
			            case 5:
			                utcRaw = strdup(pV);
			                break;
			         }

			         cnt++;

			    }  // end for()

			    memcpy(latDg, &latRaw[0], 2);
			    latDg[2] = '\0';

			    memcpy(latMS, &latRaw[2], 7);
			    latMS[7] = '\0';

			    memcpy(lonDg, &lonRaw[0], 3);
			    lonDg[3] = '\0';

			    memcpy(lonMS, &lonRaw[3], 7);
			    lonMS[7] = '\0';
			    char strLonMS[7];
			    sprintf(strLonMS, "%s", lonMS);

			    //converting the UTC time in the hh:mm:ss format
			    memcpy(hH, &utcRaw[0], 2);
			    hH[2] = '\0';

			    memcpy(mM, &utcRaw[2], 2);
			    mM[2] = '\0';

			    memcpy(sS, &utcRaw[4], 2);
			    sS[2] = '\0';

			    strcpy(strUTC, hH);
			    strcat(strUTC, ":");
			    strcat(strUTC, mM);
			    strcat(strUTC, ":");
			    strcat(strUTC, sS);
			    strUTC[8] = '\0';

			    latitude = atof(latDg)+((atof(latMS))/60);
			    longitude = atof(lonDg)+((atof(strLonMS))/60);

			} // end of of the checksum data verification

		} // end of $GNGLL sentences selection

	} // end of splitting the buffStr by the "\n" delimiter with the strsep() C function
}



void Send_GPS_Gyro_Accel_data(int id, float ax, float ay, float az, float gx, float gy, float gz, float latitude, float longitude, float temp){
	char res_ax[6];
	char res_ay[6];
	char res_az[6];
	char res_gx[8];
	char res_gy[8];
	char res_gz[8];
	char res_lat[10];
	char res_lon[10];
	char res_temp[6];
	char res_id[5];

	snprintf(res_ax, sizeof res_ax, "%f", ax);
	snprintf(res_ay, sizeof res_ay, "%f", ay);
	snprintf(res_az, sizeof res_az, "%f", az);
	snprintf(res_gx, sizeof res_gx, "%f", gx);
	snprintf(res_gy, sizeof res_gy, "%f", gy);
	snprintf(res_gz, sizeof res_gz, "%f", gz);
	snprintf(res_lat, sizeof res_lat, "%f", latitude);
	snprintf(res_lon, sizeof res_lon, "%f", longitude);
	snprintf(res_temp, sizeof res_temp, "%f", temp);
	snprintf(res_id, sizeof res_id, "%d", id);


	char comm[11]="<";
	strcat(comm, res_id);
	strcat(comm, ">lat=");


	uint8_t DATA_SIZE_GPS = 10;
	uint8_t DATA_SIZE_GYRO = 8;
	uint8_t DATA_SIZE_ACCEL = 6;
	uint8_t DATA_SIZE_TEMP = 5;
	uint8_t COMMAND_SIZE=sizeof(comm);
	char  out[COMMAND_SIZE+2*(DATA_SIZE_GPS)+3*(DATA_SIZE_ACCEL)+3*(DATA_SIZE_GYRO)+DATA_SIZE_TEMP+16];


	strcpy(out, comm);
	strcat(out, res_lat);
	strcat(out, "lon=");
	strcat(out, res_lon);
	strcat(out, "ax=");
	strcat(out, res_ax);
	strcat(out, "ay=");
	strcat(out, res_ay);
	strcat(out, "az=");
	strcat(out, res_az);
	strcat(out, "gx=");
	strcat(out, res_gx);
	strcat(out, "gy=");
	strcat(out, res_gy);
	strcat(out, "gz=");
	strcat(out, res_gz);
	strcat(out, "tmp=");
	strcat(out, res_temp);

	int len = strlen(out);
	char hex_str[(len*2)+1];

	string2hexString(out, hex_str);

	char comm2[]="AT+TXT=1,";
	uint16_t DATA_SIZE2 = strlen(hex_str);
	uint8_t COMMAND_SIZE2=sizeof(comm2);
	char src111[DATA_SIZE2], out2[COMMAND_SIZE2+DATA_SIZE2];
	strcpy(src111, hex_str);
	strcpy(out2, comm2);
	strcat(out2, src111);

	int i;
	for(i=0;i<sizeof(out2);i++){
		Usart6Send(out2[i]);
	}
	Usart6Send(13);
}

