﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using GMap.NET;
using GMap.NET.WindowsForms;
using GMap.NET.WindowsForms.Markers;
using GMap.NET.MapProviders;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Windows.Forms.DataVisualization.Charting;

namespace Vizualizace
{
    public partial class Form1 : Form
    {
		//inicializace serveru
        TcpListener server = null;
        CancellationTokenSource cts = new CancellationTokenSource();
		
		//inicializace promenych
        String _data = null;
        DateTime dt;
        double latitude, longitude, ax, ay, az, gx, gy, gz, temperature;
        double old_ax = 0;
        string date, time;
        int id, signal, tbid1, tbid2;
        int i =0;

        private void timer1_Tick(object sender, EventArgs e)
        {
			//aktualni cas
            dt = DateTime.Now;
            lblTime.Text = "" + dt;

			//pokud jsou prijata data
            if (_data != null)
            {
                try //zpracovani dat prevod textu na cislo
                {
                    id = int.Parse(_data.Substring(0, 4), System.Globalization.CultureInfo.InvariantCulture);
                    date = _data.Substring(5, 10);
                    time = getBetween(_data, "T", ",");
                    signal = int.Parse(getBetween(_data, ",", ","), System.Globalization.CultureInfo.InvariantCulture);
                    latitude = double.Parse(getBetween(_data, "lat=", "lon="), System.Globalization.CultureInfo.InvariantCulture);
                    longitude = double.Parse(getBetween(_data, "lon=", "ax="), System.Globalization.CultureInfo.InvariantCulture);
                    ax = double.Parse(getBetween(_data, "ax=", "ay="), System.Globalization.CultureInfo.InvariantCulture);
                    ay = double.Parse(getBetween(_data, "ay=", "az="), System.Globalization.CultureInfo.InvariantCulture);
                    az = double.Parse(getBetween(_data, "az=", "gx="), System.Globalization.CultureInfo.InvariantCulture);
                    gx = double.Parse(getBetween(_data, "gx=", "gy="), System.Globalization.CultureInfo.InvariantCulture);
                    gy = double.Parse(getBetween(_data, "gy=", "gz="), System.Globalization.CultureInfo.InvariantCulture);
                    gz = double.Parse(getBetween(_data, "gz=", "tmp="), System.Globalization.CultureInfo.InvariantCulture);
                    temperature = double.Parse(getBetween(_data, "tmp=", ";"), System.Globalization.CultureInfo.InvariantCulture);
                    tbid1 = int.Parse(tbID1.Text);
                    tbid2 = int.Parse(tbID2.Text);
                }
                catch (FormatException er)
                {
                    Console.WriteLine(er.Message);
                }

                if(id == tbid1) //rozdeleni dle ID1
                {
					//vlozeni dat do vizualizace
                    lblLat1.Text = "" + latitude;
                    lblLon1.Text = "" + longitude;
                    lblID1.Text = "" + id;
                    lblRSSI1.Text = "" + signal;
                    lblTemp1.Text = "" + temperature;
                    lblDate1.Text = date + " čas:" + time;

					//kontola zda jsou platna data GPS
					//pokud ano vlozeni souradnic do vizualizace
                    if (latitude != 0 && longitude != 0)
                    {
                        PointLatLng pos = new PointLatLng(latitude, longitude);
                        GMapOverlay markersOverlay1 = new GMapOverlay("markers");
                        GMarkerCross marker = new GMarkerCross(pos);
                        markersOverlay1.Markers.Add(marker);
                        gMap.Overlays.Add(markersOverlay1);
                        gMap.Position = pos;
                    }

					//vizualizace dat do grafu
                    if(old_ax != ax)
                    {

                        ChartArea ca = chAccel1.ChartAreas["ChartArea1"];

                        int xi = chAccel1.Series["Ax"].Points.AddY(ax);
                        chAccel1.Series["Ay"].Points.Add(ay);
                        chAccel1.Series["Az"].Points.Add(az);


                        ca.AxisX.Minimum = double.NaN;
                        ca.AxisX.Maximum = double.NaN;
                        ca.RecalculateAxesScale();

						//upraveni zobrazeni grafu
                        ca.AxisX.ScaleView.Zoom(0.0,50.0);
                        if(xi < 25)
                        {
                            ca.AxisX.ScaleView.Position = xi;
                        }
                        else
                        {
                            ca.AxisX.ScaleView.Position = xi - 25;
                        }


                        ChartArea ca2 = chGyro1.ChartAreas["ChartArea1"];

                        int xi2 = chGyro1.Series["Gx"].Points.AddY(gx);
                        chGyro1.Series["Gy"].Points.Add(gy);
                        chGyro1.Series["Gz"].Points.Add(gz);


                        ca2.AxisX.Minimum = double.NaN;
                        ca2.AxisX.Maximum = double.NaN;
                        ca2.RecalculateAxesScale();

						//upraveni zobrazeni grafu
                        ca2.AxisX.ScaleView.Zoom(0.0, 50.0);
                        if (xi2 < 25)
                        {
                            ca2.AxisX.ScaleView.Position = xi2;
                        }
                        else
                        {
                            ca2.AxisX.ScaleView.Position = xi2 - 25;
                        }
                    }

                    old_ax = ax;
                }

                if (id == tbid2) // rozdeleni dle ID2
                {
					//vlozeni dat do vizualizace
                    lblLat2.Text = "" + latitude;
                    lblLon2.Text = "" + longitude;
                    lblID2.Text = "" + id;
                    lblRSSI2.Text = "" + signal;
                    lblTemp2.Text = "" + temperature;
                    lblDate2.Text = date + " čas:" + time;

					//kontola zda jsou platna data GPS
					//pokud ano vlozeni souradnic do vizualizace
                    if (latitude != 0 && longitude != 0)
                    {
                        PointLatLng pos = new PointLatLng(latitude, longitude);
                        GMapOverlay markersOverlay2 = new GMapOverlay("markers");
                        GMarkerCross marker = new GMarkerCross(pos);
                        markersOverlay2.Markers.Add(marker);
                        gMap.Overlays.Add(markersOverlay2);
                        gMap.Position = pos;
                    }

					//vizualizace dat do grafu
                    if (old_ax != ax)
                    {

                        ChartArea ca = chAccel2.ChartAreas["ChartArea1"];

                        int xi = chAccel2.Series["Ax"].Points.AddY(ax);
                        chAccel2.Series["Ay"].Points.Add(ay);
                        chAccel2.Series["Az"].Points.Add(az);


                        ca.AxisX.Minimum = double.NaN;
                        ca.AxisX.Maximum = double.NaN;
                        ca.RecalculateAxesScale();

                        //upraveni zobrazeni grafu    
                        ca.AxisX.ScaleView.Zoom(0.0, 50.0);
                        if (xi < 25)
                        {
                            ca.AxisX.ScaleView.Position = xi;
                        }
                        else
                        {
                            ca.AxisX.ScaleView.Position = xi - 25;
                        }


                        ChartArea ca2 = chGyro2.ChartAreas["ChartArea1"];

                        int xi2 = chGyro2.Series["Gx"].Points.AddY(gx);
                        chGyro2.Series["Gy"].Points.Add(gy);
                        chGyro2.Series["Gz"].Points.Add(gz);


                        ca2.AxisX.Minimum = double.NaN;
                        ca2.AxisX.Maximum = double.NaN;
                        ca2.RecalculateAxesScale();

                        //upraveni zobrazeni grafu    
                        ca2.AxisX.ScaleView.Zoom(0.0, 50.0);
                        if (xi2 < 25)
                        {
                            ca2.AxisX.ScaleView.Position = xi2;
                        }
                        else
                        {
                            ca2.AxisX.ScaleView.Position = xi2 - 25;
                        }
                    }

                    old_ax = ax;
                }

            }
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
			//inicializace mapy
            gMap.MapProvider = GMap.NET.MapProviders.CzechMapProvider.Instance;
            GMap.NET.GMaps.Instance.Mode = GMap.NET.AccessMode.ServerOnly;
            gMap.ShowCenter = false;
            gMap.DragButton = MouseButtons.Left;
            gMap.MapProvider = GMapProviders.CzechMap;
            gMap.MinZoom = 2;
            gMap.MaxZoom = 50;
            gMap.Zoom = 15;

        }

        private void btnConnect_Click(object sender, EventArgs e) 
        {
			//udalosti pri kliknuti na tlacitko Pripojit
            if (btnConnect.Text == "Připojit")
            {
                btnConnect.Text = "Odpojit";
                cts.Dispose(); 
                cts = new CancellationTokenSource(); 
                server = new TcpListener(IPAddress.Any, 9999);
                server.Start();
                HandleConnectionAsync(server, cts.Token);
            }
            else
            {
                btnConnect.Text = "Připojit";
                cts.Cancel();
                server.Stop();
                lblServerStatus.Text = "Odpojeno";
                _data = null;
            }
        }


        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
			//zastaveni serveru a ukonceni komunikace
            cts.Cancel();
            try
            {
                server.Stop();
            }
            catch (FormatException er)
            {
                Console.WriteLine(er.Message);
            }

            Thread.Sleep(2500);
            cts.Dispose();
        }

		//funkce pro ziskani retezce znaku mezi dvemi retezci znaku
        public static string getBetween(string strSource, string strStart, string strEnd)
        {
            if (strSource.Contains(strStart) && strSource.Contains(strEnd))
            {
                int Start, End;
                Start = strSource.IndexOf(strStart, 0) + strStart.Length;
                End = strSource.IndexOf(strEnd, Start);
                return strSource.Substring(Start, End - Start);
            }

            return "";
        }

        async Task HandleConnectionAsync(TcpListener listener, CancellationToken ct)
        {
			//Navazani komunikace s klientem
            lblServerStatus.Text = "Připojování";
            while (!ct.IsCancellationRequested)
            {
                TcpClient client = await listener.AcceptTcpClientAsync();
                lblServerStatus.Text = "Klient připojen";
                EchoAsync(client, ct);
            }
        }

        async Task EchoAsync(TcpClient client, CancellationToken ct)
        {
			//Prijem dat od klienta
            Byte[] bytes = new Byte[256];
            NetworkStream stream = client.GetStream();

            while (!ct.IsCancellationRequested)
            {
                var amountRead = await stream.ReadAsync(bytes, 0, bytes.Length, ct);
                _data = System.Text.Encoding.ASCII.GetString(bytes, 0, bytes.Length);
                if (amountRead == 0) break;
            }
        }
    }
}
